/*
 *
 * by Nakamura Noritsugu
 * from 2000.06.16
 */

#include "ruby.h"
#include <jlib.h>

static VALUE mLibjcode;

static VALUE
rb_ext_Libjcode_detectKanjiCode(VALUE class, VALUE str)
{
  return INT2FIX(detectKanjiCode(STR2CSTR(str)));
}

static VALUE
rb_ext_Libjcode_toStringJIS(VALUE class, VALUE str)
{
  return rb_str_new2(toStringJIS(STR2CSTR(str)));
}

static VALUE
rb_ext_Libjcode_toStringEUC(VALUE class, VALUE str)
{
  return rb_str_new2(toStringEUC(STR2CSTR(str)));
}

static VALUE
rb_ext_Libjcode_toStringSJIS(VALUE class, VALUE str)
{
  return rb_str_new2(toStringSJIS(STR2CSTR(str)));
}


void
Init_libjcode(){
  mLibjcode = rb_define_module("Libjcode");

  rb_define_module_function(mLibjcode, "guess", rb_ext_Libjcode_detectKanjiCode, 1);
  rb_define_module_function(mLibjcode, "tojis", rb_ext_Libjcode_toStringJIS, 1);
  rb_define_module_function(mLibjcode, "toeuc", rb_ext_Libjcode_toStringEUC, 1);
  rb_define_module_function(mLibjcode, "tosjis", rb_ext_Libjcode_toStringSJIS, 1);

  rb_define_const(mLibjcode, "ASCII", INT2FIX(ASCII));
  rb_define_const(mLibjcode, "JIS", INT2FIX(JIS));
  rb_define_const(mLibjcode, "EUC", INT2FIX(EUC));
  rb_define_const(mLibjcode, "SJIS", INT2FIX(SJIS));
}
